% compile_basins

clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));

%% Compile basins

% make shapefile to edit:
B = shaperead('Basins_IMBIE_Antarctica_v02.shp');
M = shaperead('GroundingLine_Antarctica_v02.shp');
Mx = M.X;
My = M.Y;
[~,on] = inpoly2([Mx(:),My(:)],[B(1).X(:),B(1).Y(:)]);
on = logical(1-on); % invert
Mx = Mx(on);
My = My(on);
S.Geometry = 'Polygon';
S.X = Mx;
S.Y = My;
shapewrite(S,'AIS_GL_to_edit.shp');
% Then manually remove self-intersections and a gap near Atka

% Full ice sheet
count = 1;
names{count} = 'Antarctica';
S = shaperead('AIS_GL_to_edit.shp'); % this has been edited as above
x{count} = S.X(:);
y{count} = S.Y(:);
type{count} = 'ice_sheet';
type_ID(count) = 0;
[lat,lon] = ps2ll(x{count},y{count});
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));

% Main ice sheet rignot
filename = 'basins_IMBIE_v2.mat';
B = load(filename);
%   - west
count = count+1;
pcount = 0;
clear p
for i = [10:13,17]
    pcount = pcount+1;
    disp(num2str(pcount));
    tmpx = [B.x{i};NaN];
    tmpy = [B.y{i};NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
names{count} = 'West_Antarctica_Rignot';
type{count} = 'ice_sheet_Rignot';
type_ID(count) = 6;
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
[lat,lon] = ps2ll(x,y);
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
%	- east
count = count+1;
pcount = 0;
clear p
for i = [2:9,18,19]
    pcount = pcount+1;
    disp(num2str(pcount));
    tmpx = [B.x{i};NaN];
    tmpy = [B.y{i};NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
names{count} = 'East_Antarctica_Rignot';
type{count} = 'ice_sheet_Rignot';
type_ID(count) = 6;
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
[lat,lon] = ps2ll(x,y);
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
% 	- peninsula
count = count+1;
pcount = 0;
clear p
for i = [2:9,18,19]
    pcount = pcount+1;
    disp(num2str(pcount));
    tmpx = [B.x{i};NaN];
    tmpy = [B.y{i};NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
names{count} = 'Peninsula_Rignot';
type{count} = 'ice_sheet_Rignot';
type_ID(count) = 6;
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
[lat,lon] = ps2ll(x,y);
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));

% Main ice sheet zwally
B = load('basins_grounded.mat');
[B.x,B.y] = ll2ps(B.lat,B.lon);
unique_basins = unique(B.basin);
num_basins = length(unique_basins);
%   - west
count = count+1;
names{count} = 'West_Antarctica_Zwally';
pcount = 0;
clear p
for i = [1,18:23]
    pcount = pcount+1;
    ind = ismember(B.basin,i);
    tmpx = [B.x(ind);NaN];
    tmpy = [B.y(ind);NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
type{count} = 'ice_sheet_Zwally';
type_ID(count) = 7;
[lat,lon] = ps2ll(x{count},y{count});
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
%   - east
count = count+1;
names{count} = 'East_Antarctica_Zwally';
pcount = 0;
clear p
for i = 2:17
    pcount = pcount+1;
    ind = ismember(B.basin,i);
    tmpx = [B.x(ind);NaN];
    tmpy = [B.y(ind);NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
type{count} = 'ice_sheet_Zwally';
type_ID(count) = 7;
[lat,lon] = ps2ll(x{count},y{count});
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
%   - peninsula
count = count+1;
names{count} = 'Peninsula_Zwally';
pcount = 0;
clear p
for i = 24:27
    pcount = pcount+1;
    ind = ismember(B.basin,i);
    tmpx = [B.x(ind);NaN];
    tmpy = [B.y(ind);NaN];
    p(pcount) = polyshape(tmpx,tmpy);
end
p0 = union(p);
x{count} = p0.Vertices(:,1);
y{count} = p0.Vertices(:,2);
type{count} = 'ice_sheet_Zwally';
type_ID(count) = 7;
[lat,lon] = ps2ll(x{count},y{count});
wgs84 = wgs84Ellipsoid("km");
stats = regionprops(isfinite(lat),'PixelIdxList');
A = 0;
for k = 1:length(stats)
    A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
end
A = A * (1000*1000); % convert from km^2 to m^2
area(count) = A;
[cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
clear ind filename num_basins unique_basins B A stats wgs84 lat lon

% Large IMBIE basins
filename = 'basins_IMBIE_v2.mat';
B = load(filename);
for i = 2:numel(B.name)
    count = count+1;
    names{count} = B.name{i};
    x{count} = B.x{i};
    y{count} = B.y{i};
    type{count} = 'imbie';
    type_ID(count) = 1;
    % area
    [lat,lon] = ps2ll(x{count},y{count});
    wgs84 = wgs84Ellipsoid("km");
    stats = regionprops(isfinite(lat),'PixelIdxList');
    A = 0;
    for k = 1:length(stats)
        A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
    end
    A = A * (1000*1000); % convert from km^2 to m^2
    area(count) = A;
    % centroid
    [cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
end
clear B filename

% Refined IMBIE basins
filename = 'basins_refined_v2.mat'; 
B = load(filename);
for i = 1:numel(B.name)
    count = count+1;
    names{count} = B.name{i};
    x{count} = B.x{i};
    y{count} = B.y{i};
    type{count} = 'imbie refined';
    type_ID(count) = 2;
    % area
    [lat,lon] = ps2ll(x{count},y{count});
    wgs84 = wgs84Ellipsoid("km");
    stats = regionprops(isfinite(lat),'PixelIdxList');
    A = 0;
    for k = 1:length(stats)
        A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
    end
    A = A * (1000*1000); % convert from km^2 to m^2
    area(count) = A;
    % centroid
    [cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
end
clear B filename

% Zwally basins
B = load('basins_grounded.mat');
[B.x,B.y] = ll2ps(B.lat,B.lon);
unique_basins = unique(B.basin);
num_basins = length(unique_basins);
for i = 1:num_basins
    count = count+1;
    names{count} = unique_basins(i);
    ind = B.basin==unique_basins(i);
    x{count} = [B.x(ind);NaN];
    y{count} = [B.y(ind);NaN];
    type{count} = 'zwally';
    type_ID(count) = 3;
    % area
    [lat,lon] = ps2ll(x{count},y{count});
    wgs84 = wgs84Ellipsoid("km");
    stats = regionprops(isfinite(lat),'PixelIdxList');
    A = 0;
    for k = 1:length(stats)
        A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
    end
    A = A * (1000*1000); % convert from km^2 to m^2
    area(count) = A;
    % centroid
    [cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
end
clear B filename
% cook
B = shaperead('D:\work\Fellowship_Leeds\Data\APN_basins/NEB_Basins_reproject.shp');
for i = 1:numel(B)
    count = count+1;
    names{count} = B(i).name;
    x{count} = B(i).X(:);
    y{count} = B(i).Y(:);
    type{count} = 'Cook';
    type_ID(count) = 4;
    % area
    [lat,lon] = ps2ll(x{count},y{count});
    wgs84 = wgs84Ellipsoid("km");
    stats = regionprops(isfinite(lat),'PixelIdxList');
    A = 0;
    for k = 1:length(stats)
        A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
    end
    A = A * (1000*1000); % convert from km^2 to m^2
    area(count) = A;
    % centroid
    [cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
end
clear B filename

% ice shelves
load('D:\work\Fellowship_Leeds\Papers\Research\ice_shelf_mass_budget\v2\partitioning\basins/edited_basins.mat');
for i = 1:numel(shelf_names)
    count = count+1;
    names{count} = shelf_names{i};
    x{count} = basin_x{i};
    y{count} = basin_y{i};
    type{count} = 'shelf';
    type_ID(count) = 5;
    % area
    [lat,lon] = ps2ll(x{count},y{count});
    wgs84 = wgs84Ellipsoid("km");
    stats = regionprops(isfinite(lat),'PixelIdxList');
    A = 0;
    for k = 1:length(stats)
        A = A + areaint(lat(stats(k).PixelIdxList),lon(stats(k).PixelIdxList),wgs84); % accounts for curvature of earth
    end
    A = A * (1000*1000); % convert from km^2 to m^2
    area(count) = A;
    % centroid
    [cx(count),cy(count)] = centroid(polyshape(x{count},y{count}));
end
clear basin_x basin_y shelf_names A wgs84 lat lon stats k i

% build structure
basins.name = names';
basins.x = x';
basins.y = y';
basins.area = area';
basins.centroid = [cx(:),cy(:)];
basins.type = type';
basins.type_ID = type_ID';
basins.ID = 1:length(basins.type_ID);
save('../out/int/basins/all_basins.mat','basins');

