% plot_AIS_basins

clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));
addpath(genpath('../'));

% basins
basins = readBasinInfo;

% get limits
[~,x,y] = geoimread('../out/pub/reference_grids/FrankenBed.tif');
xlims = [min(x(:)),max(x(:))];
ylims = [min(y(:)),max(y(:))];

%% Plot IMBIE refined basins

% plot ice sheet regions
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
for i = 2:4
    plot(basins.x{i},basins.y{i},'k','linestyle','-','marker','none');
end
antbounds('coast','r');
axis off
set(gca,'XLim',xlims,'YLim',ylims);
export_fig('../out/pub/figures/basins/ice_sheet.png','-dpng','-r600');

% plot IMBIE refined basins
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
ind = find(basins.type_ID==2);
for i = 1:length(ind)
    plot(basins.x{ind(i)},basins.y{ind(i)},'k','linestyle','-','marker','none');
end
antbounds('coast','r');
axis off
set(gca,'XLim',xlims,'YLim',ylims);
export_fig('../out/pub/figures/basins/IMBIE_refined.png','-dpng','-r600');

% plot IMBIE refined basins
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
ind = find(basins.type_ID==1);
for i = 1:length(ind)
    plot(basins.x{ind(i)},basins.y{ind(i)},'k','linestyle','-','marker','none');
end
antbounds('coast','r'); 
axis off
set(gca,'XLim',xlims,'YLim',ylims);
export_fig('../out/pub/figures/basins/IMBIE_coarse.png','-dpng','-r600');

% Plot Zwallly basins
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
ind = find(basins.type_ID==3);
for i = 1:length(ind)
    plot(basins.x{ind(i)},basins.y{ind(i)},'k','linestyle','-','marker','none');
end
antbounds('coast','r'); 
axis off
set(gca,'XLim',xlims,'YLim',ylims);
export_fig('../out/pub/figures/basins/Zwally.png','-dpng','-r600');

% Ice shelf basins
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
ind = find(basins.type_ID==5);
for i = 1:length(ind)
    plot(basins.x{ind(i)},basins.y{ind(i)},'k','linestyle','-','marker','none');
end
antbounds('coast','r');
axis off
set(gca,'XLim',xlims,'YLim',ylims);
export_fig('../out/pub/figures/basins/shelf.png','-dpng','-r600');

% Cook basins
figure('color','w','units','inches','position',[1 1 3.5 3.5]);
antbounds('coast','r'); hold on;
ind = find(basins.type_ID==4);
for i = 1:length(ind)
    plot(basins.x{ind(i)},basins.y{ind(i)},'k','linestyle','-','marker','none');
end
antbounds('coast','r');
axis off
set(gca,'XLim',[-2.8966   -1.0961].*1e6,'YLim',[0.2300    1.7330].*1e6);
export_fig('../out/pub/figures/basins/Peninsula.png','-dpng','-r600');


