% genRefFirn

clear
close all
clc

if ispc
    addpath(genpath('D:/work/Fellowship_Leeds/Data'));
else
    addpath(genpath('/resstore/b0133/Data/MATLAB_tools'));
    addpath(genpath('/resstore/b0133/Data/RACMO/Antarctica/FDM_2021_update_FAC_detrended'));
end

%% Load RACMO data

% Filename
fn='FDMv1.2A_FirnAir_ANT27_1979-2021_detrended.nc';

% Time
num_ts =  length(ncread(fn,'time'));
time = datenum(1979,1,10):10:datenum(1979,1,10)+(num_ts-1)*10;
tidx = find(time >= datenum(1979,1,1)); 
time = time(tidx); % subsample time period

% Get grids
lat = ncread(fn,'lat');
lon = ncread(fn,'lon');
[fac_x,fac_y] = ll2ps(lat,lon);

% Read gridded data
zs = ncread(fn,'FirnAir');


% Make 30-year climatology
idx = find(time>=datenum(1979,1,1) & time<=datenum(2009,1,1));
fac_clim_2D = nanmean(zs(:,:,idx),3); 
fac_clim_2D([1,end],:) = 0;
fac_clim_2D(:,[1,end]) = 0;
fac_clim_2D = regionfill(fac_clim_2D,isnan(fac_clim_2D));

% save
save('../out/pub/reference_grids/FAC_clim_2D.mat','fac_clim_2D','fac_x','fac_y');

