% calc_bed_impact

clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));
addpath(genpath('../'));

% basin info
basins = readBasinInfo;

% Load data
%   - discharge
FB_bQ = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_mean');
FBA_bQ = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBedAdj.nc','discharge_mean');
BM_bQ = ncread('../out/pub/discharge/nc/AIS_discharge_BedMachine.nc','discharge_mean');
B2_bQ = ncread('../out/pub/discharge/nc/AIS_discharge_BedMap2.nc','discharge_mean');
%   - error
FB_se = 1.96.*ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_standard_error');
FBA_se = 1.96.*ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBedAdj.nc','discharge_standard_error');
BM_se = 1.96.*ncread('../out/pub/discharge/nc/AIS_discharge_BedMachine.nc','discharge_standard_error');
B2_se = 1.96.*ncread('../out/pub/discharge/nc/AIS_discharge_BedMap2.nc','discharge_standard_error');


% Compare Antarctica average discharge
disp(['FrankenBed average: ' num2str(nanmean(FB_bQ(1,:),2)) ' Gt/yr ']);
disp(['BedMachine average: ' num2str(nanmean(BM_bQ(1,:),2)) ' Gt/yr ']);
disp(['BedMap2 average: ' num2str(nanmean(B2_bQ(1,:),2)) ' Gt/yr ']);
disp(['FrankenBeAdj average: ' num2str(nanmean(FBA_bQ(1,:),2)) ' Gt/yr ']);

% What is the difference?
avg_diff = nanmean([abs(nanmean(FB_bQ(1,:),2)-nanmean(BM_bQ(1,:),2)) ;...
    abs(nanmean(FB_bQ(1,:),2)-nanmean(B2_bQ(1,:),2)) ;...
    abs(nanmean(BM_bQ(1,:),2)-nanmean(B2_bQ(1,:),2)) ]);
disp(['Excluding FrankenBedAdj, the average difference between bed datasets is: ' num2str(avg_diff) ' Gt/yr']);
disp(['FB minus BM: ' num2str((nanmean(FB_bQ(1,:),2) - nanmean(BM_bQ(1,:),2))./nanmean(FB_bQ(1,:),2).*100) ' %']);
disp(['FB minus B2: ' num2str((nanmean(FB_bQ(1,:),2) - nanmean(B2_bQ(1,:),2))./nanmean(FB_bQ(1,:),2).*100) ' %']);
disp(' ');

% What is the difference in:
%   - West Antarctica
disp('West Antarctica')
disp(['West: FB minus BM: ' num2str((nanmean(FB_bQ(2,:),2) - nanmean(BM_bQ(2,:),2))./nanmean(FB_bQ(2,:),2).*100) ' %']);
disp(['West: FB minus B2: ' num2str((nanmean(FB_bQ(2,:),2) - nanmean(B2_bQ(2,:),2))./nanmean(FB_bQ(2,:),2).*100) ' %']);
disp(' ');
%   - East Antarctica
disp('East Antarctica')
disp(['East: FB minus BM: ' num2str((nanmean(FB_bQ(3,:),2) - nanmean(BM_bQ(3,:),2))./nanmean(FB_bQ(3,:),2).*100) ' %']);
disp(['East: FB minus B2: ' num2str((nanmean(FB_bQ(3,:),2) - nanmean(B2_bQ(3,:),2))./nanmean(FB_bQ(3,:),2).*100) ' %']);
disp(' ');
%   - Peninsula
disp('Peninsula')
disp(['APN: FB minus BM: ' num2str((nanmean(FB_bQ(4,:),2) - nanmean(BM_bQ(4,:),2))./nanmean(FB_bQ(4,:),2).*100) ' %']);
disp(['APN: FB minus B2: ' num2str((nanmean(FB_bQ(4,:),2) - nanmean(B2_bQ(4,:),2))./nanmean(FB_bQ(4,:),2).*100) ' %']);
disp(' ');


% What is the percentage difference in individual basins
FB_minus_BM = (nanmean(FB_bQ,2) - nanmean(BM_bQ,2))./nanmean(FB_bQ,2).*100;
FB_minus_B2 = (nanmean(FB_bQ,2) - nanmean(B2_bQ,2))./nanmean(FB_bQ,2).*100;

histogram(FB_minus_BM(basins.type_ID==2),'binwidth',2.5);
histogram(FB_minus_BM(basins.type_ID==4),'binwidth',2.5);
