% calc_gate_impact

clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));
addpath(genpath('../'));

% basin info
basins = readBasinInfo;

% Load data
time = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','time') + datenum(1950,1,1,0,0,0);
Q = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_all_gates');
Qavg = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_mean');
Q_timeavg = squeeze(nanmean(Q,2));

% Calculate relative difference between gates
rel_diff = (Q-Qavg)./Qavg.*100;
flux_diff = Q-Qavg;
avg_flux_diff = squeeze(nanmean(flux_diff,2)); % time-average

%% Antarctic wide differences

up_vs_down = Q_timeavg(1,1) - Q_timeavg(1,end);
disp(['Antarctic-wide, discharge differs by ' num2str(up_vs_down) ' Gt (' num2str(up_vs_down./Q_timeavg(1,1).*100) '%)' ]);

%% Peninsula

up_vs_down = Q_timeavg(4,1) - Q_timeavg(4,end);
up_vs_mid = Q_timeavg(4,end) - nanmean(Qavg(4,:),2);
down_vs_mid = Q_timeavg(4,1) - nanmean(Qavg(4,:),2);
updown_vs_mid = nanmean([up_vs_mid,down_vs_mid]);
disp(['Peninsula up-vs-down discharge differs by ' num2str(up_vs_down) ' Gt (' num2str(up_vs_down./nanmean(Qavg(4,:),2).*100) '%)' ]);
disp(['Peninsula updown-vs-mid discharge differs by ' num2str(updown_vs_mid) ' Gt (' num2str(updown_vs_mid./nanmean(Qavg(4,:),2).*100) '%)' ]);

%% Pine Island

idx = find(strcmp(basins.name,'Pine Island')==1,1,'first');
up_vs_down = Q_timeavg(idx,1) - Q_timeavg(idx,end);
up_vs_mid = Q_timeavg(idx,end) - nanmean(Qavg(idx,:),2);
disp(['PIG discharge differs by ' num2str(up_vs_down) ' Gt (' num2str(up_vs_down./Q_timeavg(idx,1).*100) '%)' ]);
disp(['PIG discharge differs by ' num2str(up_vs_mid) ' Gt (' num2str(up_vs_mid./nanmean(Qavg(idx,:),2).*100) '%)' ]);

%% Ronne

idx = find(strcmp(basins.name,'Ronne_IS')==1,1,'first');
up_vs_down = Q_timeavg(idx,1) - Q_timeavg(idx,end);
idx = find(strcmp(basins.name,'Filchner_IS')==1,1,'first');
up_vs_down = up_vs_down + (Q_timeavg(idx,1) - Q_timeavg(idx,end));

disp(['Ronne discharge differs by ' num2str(up_vs_down) ' Gt/yr' ]);
