% calc_mass_balance
% didn't really get very far with this...

clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));
addpath(genpath('../'));

%% Main

% Basins
basins = readBasinInfo;

% balance discharge
Qbal = load('../out/pub/discharge/balance/balance_discharge.mat');

% SMB anomaly timeseries (Gt/yr)
smb = load('../out/int/derived/basin_smb_anom.mat');
smb.anom_smooth = movmean(smb.ens_smb_anom,60,2,'omitnan');
smb.err = abs(smb.anom_smooth).*0.1; % placeholder

% Get full SMB
time = load('basin_smb_anom.mat');
time = time.smb_time;
smb = Qbal.Qbal_ens + smb.anom_smooth;

% discharge
bQ = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_mean');
Qtime = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','time')+datenum(1950,1,1,0,0,0);

% add negligible random noise to time
Qtime = [time(1),Qtime];
a = -0.000001;
b = 0.000001;
r = a + (b-a).*rand(1,length(Qtime));
Qtime = Qtime + r;
Qtime = sort(Qtime);
        

% interpolate discharge to SMB time
Q = zeros([numel(basins.name),length(time)]).*NaN;
for i = 1:numel(basins.name)
    ts = bQ(i,:);
    ts = [Qbal.Qbal_ens(i),ts]; % assume balance discharge in 1979
    ts = interp1(Qtime,ts,time,'pchip');
    Q(i,:) = ts;
end

% calculate mass change
MB = smb-Q; % units: Gt/yr, every month

% Accumulate the mass change from April 2002, to compare with GRACE
idx = time>=datenum(1996,4,1);
Gtime = time(idx);
MBc = cumsum(MB(:,idx)./12,2); 

% GRACE gives mass change relative to Jan 2011, so set that as zero
idx = find(Gtime>datenum(2011,1,1),1,'first');
MBc = MBc - MBc(:,idx);

% plot
plot(Gtime,MBc(1,:),'ko'); datetick('x');


