% calc_thickness_impact_81south


clear
close all
clc

addpath(genpath('D:/work/Fellowship_Leeds/Data'));
addpath(genpath('../'));

%% Contribution of pixels south of 81.5

g = shaperead('../out/pub/gates/flux_gates.shp');
gate_x = g(1).X;
gate_y = g(1).Y;
[gate_lat,gate_lon] = ps2ll(gate_x,gate_y);

% Load full pixel-based discharge
load('../out/int/discharge/pixel/discharge_timeseries_migrate_0m_FrankenBed.mat','Q');

% Get time-average
Q = nanmean(Q,2); 
Qtot = nansum(Q); % time-average AIS-wide discharge

% Get discharge south of 81.5
south = gate_lat<=-81.5; 
Qtot_south = nansum(Q(south)); % total discharge south of 81.5

% contribution of those pixels to pan-Antarctic discharge
prop = Qtot_south/Qtot*100;
disp(['Pixels south of 81.5 contribute ' num2str(prop) ' % to AIS-wide discharge']);


%% Contribution of thickness changes everywhere

FB_mean = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','discharge_mean');
corrections.dH = ncread('../out/pub/discharge/nc/AIS_discharge_FrankenBed.nc','dH_correction_all_gates');
corrections.dH = squeeze(squeeze(corrections.dH(1,:,1)));
thickness_impact = max(corrections.dH); % get the maximum possible impact
prop = thickness_impact./Qtot*100; % compared to the time-average discharge
disp(['AIS-wide thickness changes change discharge by ' num2str(prop) ' % at most']);

