function basins = readBasinInfo

% Prepare basin info
ID0 = ncread('basins.nc','basin_type_ID');
x0 = ncread('basins.nc','perim_x');
y0 = ncread('basins.nc','perim_y');
centroid_x = ncread('basins.nc','centroid_x');
centroid_y = ncread('basins.nc','centroid_y');

% Make the coordinates easier to work with
x = cell([length(ID0),1]);
y = cell([length(ID0),1]);
for i = 1:length(ID0)
    bx = x0(i,:); 
    by = y0(i,:);
    idx = strfind( isnan(bx), true(1,3) );
    if ~isempty(idx)
        idx = idx(1)-1;
        bx = bx(1:idx); 
        by = by(1:idx);
    end
    x{i} = bx;
    y{i} = by;
end

% make a structure to hold it all 
basins = struct();
basins.name = cellstr(ncread('basins.nc','basin_name'));
basins.x = x;
basins.y = y;
basins.type_ID = ID0;
basins.type = cellstr(ncread('basins.nc','basin_type'));
basins.centroid = [centroid_x, centroid_y];

end