function balance_discharge_to_csv(basins,balance_discharge,outfile)

% Get basin info
names = char(string([basins.name])); 
type = char(string([basins.type])); 
type_ID = [basins.type_ID]; 
basin_ID = 1:length(type_ID);
basin_x = basins.centroid(:,1);
basin_y = basins.centroid(:,2);

% Set full outfile
if contains(outfile,'all')
    outfile = ['../out/int/discharge/balance/' outfile ];
else
    outfile = ['../out/pub/discharge/balance/' outfile ];
end

% Delete existing csv
command = ['rm -f ' outfile]; system(command);

% Make table
T = table(basin_ID(:),names,type,type_ID,basin_x,basin_y,...
    balance_discharge.Qbal_RACMO,balance_discharge.Qbal_err_RACMO,...
    balance_discharge.Qbal_HIRHAM,balance_discharge.Qbal_err_HIRHAM,...
    balance_discharge.Qbal_MAR,balance_discharge.Qbal_err_MAR,...
    balance_discharge.Qbal_ens,balance_discharge.Qbal_err_ens,...
    'VariableNames',{'basin_ID','basin_name','basin_type','basin_type_ID',...
    'basin_centroid_x','basin_centroid_y',...
    'RACMO (Gt/yr)','RACMO error (Gt/yr)','HIRHAM (Gt/yr)','HIRHAM error (Gt/yr)',...
    'MAR (Gt/yr)','MAR error (Gt/yr)','Ensemble (Gt/yr)','Ensemble error (Gt/yr)'});

% Save table
writetable(T,outfile);
    


end
